#!/usr/bin/env node

const shelljs = require('shelljs')
const chalk = require('chalk')
const figlet = require('figlet')
const inquirer = require('inquirer')

const iniciar = () => {
    console.log(
        chalk.green(
            figlet.textSync("Ficheros Generator", {
                font: "Bubble",
                horizontalLayout: "default",
                verticalLayout: "default"
            })
        )
    )
}

const hacerPreguntas = () => {
    const preguntas = [
        {
            name: "FICHERO",
            type: "input",
            message: "Ingrese nombre de fichero(sin extensión):"
        },
        {
            name: "EXTENSIÓN",
            type: "list",
            message: "¿Que extensión tiene tu fichero?",
            choices: [".js", ".ts", ".jsx", ".tsx"],
            filter: function (val) {
                return val.split(".")[1]
            }
        }
    ]
    return inquirer.prompt(preguntas)
}

const crearFichero = (nombreFichero, extension) => {
    const pathFichero = `${process.cwd()}/${nombreFichero}.${extension}`
    shelljs.touch(pathFichero)
    return pathFichero;
}

const ficheroOK = (filepath) => {
    console.log(
        chalk.white.bgGreen.bold(
            `!Fichero creado correctament en ${filepath}`
        )
    )
}

const ejecutar = async () => {
    // Mostrar la informacion de la libreria en la cabezera
    iniciar()
    // Preguntas necesarias para crear el fichero(nombre y extension)
    const respuestas = await hacerPreguntas()
    const { FICHERO, EXTENSIÓN } = respuestas
    console.log(respuestas)
    // Creamos el fechero
    const pathFichero = crearFichero(FICHERO, EXTENSIÓN)
    // Añadimos mensajes que fichero se creo con exito
    ficheroOK(pathFichero)
}

ejecutar()